module Ruby
    class Backtrace


        # Enumerable, each, and this crazy reverse are included
        # so that test/unit can use the backtrace objects just like
        # they were an array of Strings.
        
        include Enumerable

        def each
            @frames.each do |f|
                yield f.nice_string
            end
        end

        def [](num)
            @frames[num-1].nice_string
        end

        def reverse
            @frames.map { |f| f.nice_string }.reverse
        end

        def join(what)
            @frames.map { |f| f.nice_string }.join(what)
        end
        
        def contains_position?
            @line and @line > 0
        end

        def print_position
            STDERR.print "#{@file}:#{@line} in '#{@last_method}'"
        end

    end
end
