module Ruby

    # Returns a string that represents the best find for the currently
    # running ruby intepreter.
    def self.intepreter
        if File.absolute? Ruby::EXE
            return Ruby::EXE
        end
        
        if File.exists? "/proc/self/exe"
            path = File.readlink("/proc/self/exe") rescue nil
            if path
                Ruby.remove_const "EXE"
                Ruby.const_set("EXE", File.expand_path(f))
                return Ruby::EXE
            end
        end
        
        if ENV.key? "PATH"
            ENV['PATH'].each do |path|
                f = File.join(path, Ruby::EXE)
                if File.exists? f
                    Ruby.remove_const "EXE"
                    Ruby.const_set("EXE", File.expand_path(f))
                    return Ruby::EXE
                end
            end
        end

        return Ruby::EXE
    end
end

require 'state'
require 'backtrace'

