#include "ruby.h"
#include "internal.h"
#include "state.h"
#include "runtime.h"

rb_parse_state *alloc_parse_state() {
    rb_parse_state *st = (rb_parse_state*)malloc(sizeof(rb_parse_state));
    memset(st, 0, sizeof(rb_parse_state));

    st->command_start = Qtrue;
    st->class_nest = 0;
    st->in_single = 0;
    st->in_def = 0;
    st->compile_for_eval = 0;
    st->cur_mid = 0;
    st->token_buffer = NULL;
    st->tokidx = 0;
    st->toksiz = 0;

    return st;
}

void *rb_pt_mark(void *vps) {
    /*
    rb_parse_state *parse_state = (rb_parse_state*)vps;

    rb_gc_mark_maybe((VALUE)(parse_state->lval->node));
    rb_gc_mark(parse_state->lex_lastline);
    rb_gc_mark(parse_state->lex_input);
    */
    return NULL;
}

VALUE rb_pt_create() {
    rb_parse_state *st;
    st = alloc_parse_state();
    return Data_Wrap_Struct(CPATH(Ruby::ParseTree), rb_pt_mark, NULL, st);
}

void Init_runtime() {
    VALUE parser;
    rb_define_class_under(CPATH(Ruby),"ParseTree",rb_cObject);

    parser = rb_pt_create();
    
    rb_const_set(CPATH(Ruby), rb_intern("PARSER"), parser);

    rb_define_class_under(CPATH(Ruby), "State", rb_cObject);
}
