require 'test/unit'

require 'osthread'

class TestOSMutex < Test::Unit::TestCase
    def test_a1_new
        m = Thread::OS::Mutex.new
        assert_kind_of(Thread::OS::Mutex, m)
    end

    def test_op
        m = Thread::OS::Mutex.new
        c = 0
        th = Thread::OS.new do
            loop do
                m.lock
                c += 1
                m.unlock
            end
        end

        Thread::OS.yield
        m.lock
        q = c
        Thread::OS.yield
        assert_equal(q, c)
        m.unlock
        Thread::OS.yield
        assert_not_equal(q, c)
    end

    def test_trylock
        m = Thread::OS::Mutex.new
        th = Thread::OS.new do
            Signal.trap("HUP") do
                m.unlock
            end

            m.lock
            sleep 100
        end

        assert_raises(Thread::OS::Mutex::BusyMutex) do
            m.trylock
        end

        th.kill("HUP")
        sleep 1

        m.trylock
    end

    def test_recursive
        m = Thread::OS::RecursiveMutex.new

        m.lock

        assert_equal(Thread::OS.current, m.owner)

        assert_equal(false, m.lock)
    end
end
