require 'stack'
require 'backtrace'
require 'test/unit'

class TestRubyStack < Test::Unit::TestCase

    def test_push1
        Ruby::Stack[:age] = 8
        assert_equal(8, Ruby::Stack[:age])
    end

    def test_call_stack
        Ruby::Stack[:bob] = 9
        assert_equal(9, get_value)
    end

    def get_value
        Ruby::Stack[:bob]
    end

    def set_value
        Ruby::Stack[:below_me] = 99
    end

    def test_below_method_only

        set_value

        assert_equal(nil, Ruby::Stack[:below_me])
    end

    def test_yielded
        v = a(12) { b }

        assert_equal(12,v)
    end

    def a(val)
        Ruby::Stack[:yielded] = val
        yield
    end

    def b
        return Ruby::Stack[:yielded]
    end
end
